#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Version=beta
#AutoIt3Wrapper_outfile_type=a3x
#AutoIt3Wrapper_Res_Description=GUI for CHDK ptp-communication with ptpcam.exe over libusb driver
#AutoIt3Wrapper_Res_Fileversion=0.2.5.0
#AutoIt3Wrapper_Res_LegalCopyright=GPLv2 (c)2011 by CHDK community
#AutoIt3Wrapper_Run_AU3Check=n
#AutoIt3Wrapper_AU3Check_Parameters=-q -d -w 1 -w 2 -w 3 -w 4 -w 5 -w 6
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

;******************************
;Windows Gui for ptpcam.exe
;(c)2011 forum.chdk-treff.de
;authors: rudi (main),  msl, CHDKLover
;use with ptpcam.exe and libusb
;******************************

#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <SliderConstants.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Constants.au3>
#include <GuiSlider.au3>
#include <GUIComboBox.au3>
#include <GUIButton.au3>
#include <GuiStatusBar.au3>
#include <WinAPI.au3>

; everything above the 3 Opt() will be cut off by CHDK-Shell, and replaced by "...\CHDK-Shell\work\includes.au3"
Opt("TrayIconHide", 1)
Opt("GUIOnEventMode",1)
Opt('MustDeclareVars', 1)

OnAutoItExitRegister('onAutoItExit')

;Const
Const $GUI_VERSION_MAJOR = 0
Const $GUI_VERSION_MINOR = 2
Const $GUI_VERSION_REVERSION = 6
Const $PROG_NAME = "ptpCamGui"
Const $PROG_TITLE = $PROG_NAME & " " & $GUI_VERSION_MAJOR & "." & $GUI_VERSION_MINOR & "." & $GUI_VERSION_REVERSION
Const $CMD_FILENAME = "ptpcam.exe"
Const $ERR_TXT = "ERROR"
Const $CBSEND_MAX_COUNT = 20
Const $LNG_ENG = 0 ;english
Const $LNG_GER = 1 ;german
Const $LNG_NUM = 2 ;number of languages

Enum $CM_PLAY, $CM_REC
Enum $GUI_RUN, $GUI_END
Enum $CMD_RESULT_NONE, $CMD_RESULT_NIL, $CMD_RESULT_BOOL, $CMD_RESULT_INT, $CMD_RESULT_STRING, $CMD_RESULT_MULTILINE

;GUI Vars
Global $IniState = False, $IniFile = StringTrimRight(@ScriptFullPath, 3) & "ini"
Global $HookKeyProc, $HookMod, $HookHandle, $HookActive = False
Global $HelpFile = @ScriptDir & "\" & "help.txt"
Global $GuiRunState = $GUI_RUN
Global $GuiState = $GUI_ENABLE
Global $FMain, $MFile, $MFUploadFile, $MFExit,$MLang, $MLEng, $MLGer, $MHelp, $MHPrgHelp, $MHInfo
Global $BPlay, $BRec, $BShoot, $SZC, $LZCMax, $LZCVal
Global $BSend, $CBSend, $EDebug
Global $GBCamCtrl, $BCCDisp, $BCCMenu, $BCCSet, $BCCUp, $BCCDown, $BCCLeft, $BCCRight, $BCCPrint, $BCCErase, $BCamOff
Global $CBCaptureMode
Global $BGuiOff
Global $CBMotionDetection, $CBDelIni
Global $GBTimelapse, $BTLStart, $ITLTime, $LTLTime, $PTLTime, $ITLPics, $LTLPics, $LTLCurPic
Global $SB
; ==============
Global $DControl
; ==============
;GUI Language Vars
Global $LngDefault = $LNG_ENG
Global $LngMFile[$LNG_NUM] = ["File", "Datei"]
Global $LngMFUploadFile[$LNG_NUM] = ["Copy to Camera", "Kopiere auf Kamera"]
Global $LngFileSelect[$LNG_NUM] = ["Select a CHDK file:", "Whle eine CHDK-Datei aus:"]
Global $LngMFExit[$LNG_NUM] = ["Exit", "Beenden"]
Global $LngMLang[$LNG_NUM] = ["Language", "Sprache"]
Global $LngMHelp[$LNG_NUM] = ["Help", "Hilfe"]
Global $LngMHPrgHelp[$LNG_NUM] = ["Help", "Hilfe"]
Global $LngNoHelpFile[$LNG_NUM] = ["No help file available!", "Hilfe-Datei nicht verfgbar!"]
Global $LngMHInfo[$LNG_NUM] = ["About...", "ber.."]

;CHDK Vars
Global $ChdkPlatform

;Function Vars
Global $MaxZoomStep = 3
Global $ZoomStep = 0
Global $TlTime = 5
Global $TlPics = 5

;~ ========================================================================
; for array containing process info
Global $PtrProcess
;~ ========================================================================

_Main()

Func _Main()

#Region ### START Koda GUI section ### Form=
$FMain = GUICreate($PROG_TITLE, 640, 500+19, -1, -1, BitOR($WS_SIZEBOX, $WS_SYSMENU, $WS_MINIMIZEBOX))
GUISetOnEvent($GUI_EVENT_CLOSE, "onGuiClose")
;menu
$MFile = GUICtrlCreateMenu($LngMFile[$LngDefault])
$MFUploadFile = GUICtrlCreateMenuItem($LngMFUploadFile[$LngDefault], $MFile)
GUICtrlSetOnEvent($MFUploadFile, "onGuiUpload")
$MFExit = GUICtrlCreateMenuItem($LngMFExit[$LngDefault], $MFile)
GUICtrlSetOnEvent($MFExit, "onGuiClose")
$MLang = GUICtrlCreateMenu($LngMLang[$LngDefault])
$MLEng = GUICtrlCreateMenuItem("English", $MLang)
GUICtrlSetOnEvent($MLEng, "onGuiEng")
$MLGer = GUICtrlCreateMenuItem("Deutsch", $MLang)
GUICtrlSetOnEvent($MLGer, "onGuiGer")
$MHelp = GUICtrlCreateMenu($LngMHelp[$LngDefault])
$MHPrgHelp = GUICtrlCreateMenuItem($LngMHPrgHelp[$LngDefault], $MHelp)
GUICtrlSetOnEvent($MHPrgHelp, "onGuiPrghelp")
$MHInfo = GUICtrlCreateMenuItem($LngMHInfo[$LngDefault], $MHelp)
GUICtrlSetOnEvent($MHInfo, "onGuiInfo")
;Buttons left up
$BPlay = GUICtrlCreateButton("Play", 20, 20, 105, 35)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BPlay,"onBPlay")
$BRec = GUICtrlCreateButton("Record", 140, 20, 105, 35)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BRec,"onBRec")
$BShoot = GUICtrlCreateButton("Shoot", 260, 20, 105, 35)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BShoot,"onBShoot")
;Zoom Control
$SZC = GUICtrlCreateSlider(12, 72, 361, 33,BitOR($TBS_TOOLTIPS, $TBS_AUTOTICKS))
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetLimit($SZC, $maxZoomStep, 0)
_GUICtrlSlider_SetTicFreq($SZC, 1)
GUICtrlSetOnEvent($SZC,"onSZC")
$LZCMax = GUICtrlCreateLabel("max. Zoom", 240, 120, 120, 17,$SS_RIGHT)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetData($LZCMax, "max. Zoom: " & $maxZoomStep)
$LZCVal = GUICtrlCreateLabel("Zoom Step", 20, 120, 120, 17)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetData($LZCVal, "Zoom Pos: " & $ZoomStep)
;cmd
$BSend = GUICtrlCreateButton("Send", 20, 148, 105, 35)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BSend,"onBSend")
;do not change in order! named 'Edit1' for onKeyEnter
$CBSend = GUICtrlCreateCombo("", 136, 156, 473, 21)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
;Debug output
$EDebug = GUICtrlCreateEdit("", 136, 186, 473, 100, BitOR($ES_READONLY, $WS_VSCROLL))
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
;option md
$CBMotionDetection = GUICtrlCreateCheckbox("MD", 380, 30, 70, 17)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
;Mod Select
$CBCaptureMode = GUICtrlCreateCombo("Default", 480, 20, 130, 25)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetData(-1, "Auto|P|Tv|Av|M|Portrait|Night|Landscape")
GUICtrlSetOnEvent($CBCaptureMode,"onChangeCBCaptureMode")
;Group Camera Control
$GBCamCtrl = GUICtrlCreateGroup("Camera Control", 20, 300, 200, 140)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
$BCCErase = GUICtrlCreateButton("ERASE", 32, 318, 50, 20)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BCCErase,"onBCCErase")
$BCCUp = GUICtrlCreateButton("/\", 92, 318, 50, 20)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BCCUp,"onBCCUp")
$BCCPrint = GUICtrlCreateButton("PRINT", 152, 318, 50, 20)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BCCPrint,"onBCCPrint")
$BCCLeft = GUICtrlCreateButton("<", 32, 348, 50, 20)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BCCLeft,"onBCCLeft")
$BCCSet = GUICtrlCreateButton("SET", 92, 348, 50, 20)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BCCSet,"onBCCSet")
$BCCRight = GUICtrlCreateButton(">", 152, 348, 50, 20)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BCCRight,"onBCCRight")
$BCCDisp = GUICtrlCreateButton("DISP.", 32, 378, 50, 20)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BCCDisp,"onBCCDisp")
$BCCDown = GUICtrlCreateButton("\/", 92, 378, 50, 20)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BCCDown,"onBCCDown")
$BCCMenu = GUICtrlCreateButton("MENU", 152, 378, 50, 20)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BCCMenu,"onBCCMenu")
$BCamOff = GUICtrlCreateButton("Camera OFF", 32, 410, 80, 25)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BCamOff,"onBCamOff")
GUICtrlCreateGroup("", -99, -99, 1, 1)
;group Timelapse
$GBTimelapse = GUICtrlCreateGroup("Timelapse", 240, 300, 200, 140)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
$BTLStart = GUICtrlCreateButton("Start", 250, 370, 105, 35)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BTLStart,"onBTLStart")
$ITLTime = GUICtrlCreateInput("TL_Time", 250, 318, 45, 21)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetData($ITLTime, $TlTime)
$ITLPics = GUICtrlCreateInput("TL_Pics", 368, 318, 45, 21)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetData($ITLPics, $TlPics)
$LTLTime = GUICtrlCreateLabel("Time(s)", 250, 348, 45, 17)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
$LTLPics = GUICtrlCreateLabel("Pics", 368, 348, 45, 17)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
$LTLCurPic   = GUICtrlCreateLabel ("Pic 0", 368, 380, 45, 17)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
$PTLTime = GUICtrlCreateProgress(250, 420, 180, 15)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlCreateGroup("", -99, -99, 1, 1)
;Off
$BGuiOff = GUICtrlCreateButton("ptpCamGui OFF", 500, 400, 105, 35)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
GUICtrlSetOnEvent($BGuiOff, "onGuiClose")
;options
$CBDelIni = GUICtrlCreateCheckbox("delete ini", 500, 380, 70, 17)
GUICtrlSetResizing(-1, $GUI_DOCKAUTO)
;statusBar
$SB = _GUICtrlStatusBar_Create($FMain)
Global $SB_PartsWidth[4] = [80, 160, 240, -1]
_GUICtrlStatusBar_SetParts($SB, $SB_PartsWidth)
_GUICtrlStatusBar_SetText($SB, "GUI:", 0)
_GUICtrlStatusBar_SetText($SB, "ptpcam:", 1)
_GUICtrlStatusBar_SetText($SB, "camera:", 2)
_GUICtrlStatusBar_SetText($SB, "", 3)
#EndRegion ### END Koda GUI section ###
; =========================================================================
$DControl = GUICtrlCreateDummy()	; add a dummy control to the GUI, to receive our clean up event
GUICtrlSetOnEvent($DControl, "emptyWorkingSet")
; =========================================================================

;key_hook
$HookKeyProc = DllCallbackRegister("_KeyProc", "long", "int;wparam;lparam")
$HookMod = _WinAPI_GetModuleHandle(0)
$HookHandle = _WinAPI_SetWindowsHookEx($WH_KEYBOARD_LL, DllCallbackGetPtr($HookKeyProc), $HookMod)

;if german OS -> gui language german
If StringInStr("0407 0807 0c07 1007 1407", @OSLang) Then
	$LngDefault = $LNG_GER
	changeGuiLng()
EndIf
; =========================================================================
; get process info for ptpCamGui
Do
	$PtrProcess = DllCall("kernel32.dll", "ptr", "GetCurrentProcess")
Until @error = 0
; assure a clean up event message is sent every 5 sec
AdlibRegister("postGCEvent", 5000)
; =========================================================================
changeGuiState($GUI_DISABLE)
GUISetState(@SW_SHOW)
While ($GuiRunState = $GUI_RUN)
	If $GuiState = $GUI_DISABLE Then
		GUICtrlSetData($EDebug, "** init() start ..." & @CRLF, 1)
		While Not init()
			If (MsgBox( 32+4, $PROG_TITLE , "Try again?") = 7) Then Exit
		WEnd
		GUICtrlSetData($EDebug, "** init() successful" & @CRLF, 1)
		changeGuiState($GUI_ENABLE)
	Else
        $HookActive = BitAND(WinGetState($FMain), 8)
		sleep(500)
	EndIf
WEnd
EndFunc	;--End Main

;--functions
;for edit-debug
Func debugWriteLine($text)
	debugWrite($text & @CRLF)
EndFunc

Func debugWrite($text)
	GUICtrlSetData($EDebug, $text , 1)
EndFunc

;control events
Func onGuiClose()
	If GUICtrlRead($CBDelIni)=1 Then
		FileDelete($IniFile)
	Else
		If $IniState = True Then iniFileWrite()
	EndIf
	$GuiRunState = $GUI_END
EndFunc

Func onGuiUpload()
	local $UploadCHDKFile = FileOpenDialog($LngFileSelect[$LngDefault], @ScriptDir &"\", "CHDK (*.bin;*.fi2;*.fir;*.lua;*.bas)", 1)
	If @error Then Return
	FileChangeDir(@ScriptDir)
	Local $filename = StringTrimLeft($UploadCHDKFile, StringInStr($UploadCHDKFile, "\", 0, -1))
	If StringInStr($UploadCHDKFile, "bas", 0, -1) Or StringInStr($UploadCHDKFile, "lua", 0, -1) Then
		setCommand("upload "& $UploadCHDKFile &" A/CHDK/SCRIPTS/" &$filename)
	Else
		setCommand("upload "& $UploadCHDKFile &" A/" &$filename)
	EndIf
EndFunc

Func onGuiEng()
	$LngDefault = $LNG_ENG
	changeGuiLng()
EndFunc

Func onGuiGer()
	$LngDefault = $LNG_GER
	changeGuiLng()
EndFunc

Func onGuiPrgHelp()
	If FileExists($HelpFile) Then
		MsgBox(0, $LngMHelp[$LngDefault], FileRead($HelpFile))
	Else
		MsgBox(48, "Info", $LngNoHelpFile[$LngDefault])
	EndIf
EndFunc

Func onGuiInfo()
	MsgBox(0, "Info", $PROG_TITLE &@CRLF&@CRLF& "(c) 2011 by rudi feat. msl, CHDKLover" &@CRLF& "www.chdk-treff.de")
EndFunc

Func onBPlay()
	switchCamMode($CM_PLAY)
EndFunc

Func onBRec()
	switchCamMode($CM_REC)
	onChangeCBCaptureMode()
EndFunc

Func onChangeCBCaptureMode()
	If getCamMode()=$CM_REC Then
		; Auto|P|Tv|Av|M|Portrait|Night|Landscape
		Local $captureMode = _GUICtrlComboBox_GetCurSel($CBCaptureMode)
		If $captureMode <> 0 then setCommand("lua set_capture_mode("& $captureMode &")")
	EndIf
EndFunc

Func onBShoot()
	If GUICtrlRead($CBMotionDetection) = 1 Then
		setRecCommand("lua md_detect_motion()")
	Else
		setRecCommand("lua shoot()")
	EndIf
EndFunc

Func onBSend()
	Local $temp = StringStripWS(GUICtrlRead($CBSend),3)
	$temp = StringReplace($temp, "|", "\")
	If StringIsSpace($temp)or(StringLen($temp) = 0) Then Return
	setCommand($temp)
	If not @error Then
		Local $cbpos = _GUICtrlComboBox_FindStringExact($CBSend, $temp)
		If $cbpos >= 0 Then _GUICtrlComboBox_DeleteString($CBSend, $cbpos)
		_GUICtrlComboBox_InsertString($CBSend, $temp,0)
		If _GUICtrlComboBox_GetCount($CBSend) > $CBSEND_MAX_COUNT Then _GUICtrlComboBox_DeleteString($CBSend, $CBSEND_MAX_COUNT)
		_GUICtrlComboBox_SetCurSel($CBSend, -1)
		GUICtrlSetState($CBSend, $GUI_FOCUS)
	EndIf
EndFunc

Func onBTLStart()
	Opt('GUIOnEventMode', 0)
	timelapse()
	Opt('GUIOnEventMode', 1)
EndFunc

Func onSZC()
	$ZoomStep = GuiCtrlRead($SZC)
	GUICtrlSetData($SZC, $ZoomStep)
	GUICtrlSetData($LZCVal, "Zoom Pos: " & $ZoomStep)
	setRecCommand("lua set_zoom("& $ZoomStep &")")
EndFunc

Func onBCamOff()
	setCommand("shutdown")
EndFunc

Func onBCCDisp()
	setCommand("lua click('display')")
EndFunc

Func onBCCMenu()
	setCommand("lua click('menu')")
EndFunc

Func onBCCSet()
	setCommand("lua click('set')")
EndFunc

Func onBCCUp()
	setCommand("lua click('up')")
EndFunc

Func onBCCDown()
	setCommand("lua click('down')")
EndFunc

Func onBCCLeft()
	setCommand("lua click('left')")
EndFunc

Func onBCCRight()
	setCommand("lua click('right')")
EndFunc

Func onBCCPrint()
	setCommand("lua click('print')")
EndFunc

Func onBCCErase()
	setCommand("lua click('erase')")
EndFunc

;action routines
Func GetCamMode()
	Local $res = 0
	If setCommand("luar get_mode()") Then $res = 1
	Return $res
EndFunc

Func switchCamMode($Mode)
	If ($Mode<>GetCamMode())Then
		;switch to new Mode and waiting for
		setCommand("mode "&$Mode)
		While getCamMode()<>$Mode
			sleep(500)
		WEnd
	EndIf
EndFunc

Func setRecCommand($command)
	switchCamMode($CM_REC)
	setCommand($command)
EndFunc

Func setCommand($command)
; @error<>0 -> command error
; @extended -> type of result (enum CMD_RESULT_...)
;	>hint for CMD_RESULT_MULTILINE: result[0]=rowcount, first value on result[1]
; return value -> result or error-text
	Const $CONN_TEXT = "Could not find any device matching given bus/dev numbers, retrying in 1 s..."&@CRLF ;Text2=56 chars
	Local $err = 0
    Local $line = "", $lineErr = "", $res = ""
	Local $resType = $CMD_RESULT_NONE
    debugWrite(">> " & $command)
    Local $con = Run($CMD_FILENAME & ' --chdk='& '"' & $command & '"', "", @SW_HIDE , $STDOUT_CHILD + $STDERR_CHILD)
	If @error Then
		$line = "error: Can't find " & $CMD_FILENAME & @CRLF
		$err = -1
	Else
		While 1
			$line = $line & StdoutRead($con)
			If @error Then ExitLoop
		Wend
		While 1
			$lineErr = $lineErr & StderrRead($con)
			If @error Then ExitLoop
		Wend
	EndIf
    $line = StringStripWS($line,2)
	$lineErr = StringReplace($lineErr, $CONN_TEXT, "")
	If @extended > 0 Then $lineErr = StringReplace($lineErr, StringLeft($CONN_TEXT, 56), "")
	ClipPut($lineErr)
    $lineErr = StringStripWS($lineErr,2)
    debugWrite(" << "& $line & " (Length: " & StringLen($line) & ")")
    If StringLen($lineErr)>0 Then
		debugWriteLine(" ["& $lineErr & " (Length: " & StringLen($lineErr) & ")]")
	Else
		debugWriteLine('')
	EndIf
	$res = $line
	If StringLen($line)>0 Then
		If (StringInStr($line, @CRLF))or(StringInStr($line, @CR))Then
			$res = StringReplace($line, @CRLF, @CR)
			$res = StringSplit($res, @CR)
			$resType = $CMD_RESULT_MULTILINE
		Else
			If $line == "nil" Then
				$res = ""
				$resType = $CMD_RESULT_NIL
			Else
				If ($line == "false")Or($line == "true") Then
					$res = ($line == "true")
					$resType = $CMD_RESULT_BOOL
				Else
					Local $pos1 = StringInStr($line," (")
					Local $pos2 = StringInStr($line,")")
					If ($pos1 > 0)and($pos2 > $pos1)Then
						Local $dec = Int(StringLeft($line, $pos1 -1))
						If $dec = Dec(String(StringMid($line,$pos1+2,$pos2-$pos1-2))) Then
							$res = $dec
							$resType = $CMD_RESULT_INT
						EndIf
					Else
						$resType = $CMD_RESULT_STRING
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
	If $line == "unknown command" Then $err = 1
    If (StringInStr($line,"error:") > 0) Then $err = -1
	If not $err Then
    	SetExtended($resType)
        Return $res
    EndIf
	If $err < 0 Then ChangeGUIstate($GUI_DISABLE)
	MsgBox(16,$PROG_TITLE & "- Error",$line)
	SetError($err, $resType)
    Return $res
EndFunc

Func timelapse()
	GUICtrlSetData($BTLStart, "Stop")
    Local $TL_Time = GuiCtrlRead($ITLTime) * 1000
    If $TL_Time < 3000 Then $TL_Time = 3000
	IniWrite($inifile, "timelapse", "time", $TL_Time/1000)
    Local $TL_Pics = GuiCtrlRead($ITLPics)
    If $TL_Pics < 2 Then $TL_Pics = 2
	IniWrite($inifile, "timelapse", "pic", $TL_Pics)
	switchCamMode($CM_REC)
    For $i = 1 to $TL_Pics
		GUICtrlSetData($PTLTime, 0)
		Local $begin = TimerInit()
        setCommand("lua shoot()")
		GUICtrlSetData($LTLCurPic, "Pic " & $i)
		If $i < $TL_Pics Then
			Do
				Local $dif = TimerDiff($begin + $TL_Time)
				GUICtrlSetData($PTLTime, $dif*100/$TL_Time)
				sleep(10)
				local $GUIMsg = GUIGetMsg()
				If $GUIMsg = $BTLStart Then
					GUICtrlSetData($BTLStart, "Start")
					GUICtrlSetData($PTLTime, 0)
					Return -1
				EndIf
			Until $dif > ($TL_Time)
		EndIf
    Next
	GUICtrlSetData($BTLStart, "Start")
EndFunc

Func ChangeGUIstate($newState)
   If $GuiState = $newState Then Return
   Local $CGControls[27] = [   $BPlay, $BRec, $BShoot, $BSend, $CBSend, _
                  $BCamOff, $BTLStart, $ITLTime, $ITLPics, $LTLTime, _
                  $LTLPics, $LTLCurPic, $PTLTime, $BCCDisp, $BCCMenu, _
                  $BCCSet, $BCCUp, $BCCDown, $BCCLeft, $BCCRight, _
                  $BCCPrint, $BCCErase, $SZC, $LZCMax, $LZCVal, _
                  $CBCaptureMode, $CBDelIni ]
   For $i = 0 To UBound($CGControls) - 1
      GUICtrlSetState($CGControls[$i], $newState)
   Next
   $GuiState=$newState
EndFunc

Func init()
	Local Const $V_EXE = "ptpcam: ", $V_CAM = "camera: ", $V_GUI = $GUI_VERSION_MAJOR&"."&$GUI_VERSION_MINOR
	Local Const $SS_CAM = "script-support", $SS_CAM_RES = $SS_CAM & ":", $CHDK_CAM_LANG_DE = "CHDK-DE"
    $IniState = False
    Local $ptp_version = setCommand("version")
	If @error Or Not(@extended = $CMD_RESULT_MULTILINE) Then return 0
	If $ptp_version[0] = 2 Then
		Local $vGui = "GUI: "&$V_GUI
		Local $vExe = $ptp_version[1]
		Local $vCam = $ptp_version[2]
		If (StringInStr($vExe,$V_EXE)>0)And(StringInStr($vCam,$V_CAM)>0)Then
			_GUICtrlStatusBar_SetText($SB, $vGui, 0)
			_GUICtrlStatusBar_SetText($SB, $vExe, 1)
			_GUICtrlStatusBar_SetText($SB, $vCam, 2)
			If Not(StringTrimLeft($vExe, StringLen($V_EXE))==$V_GUI)And(StringTrimLeft($vCam, StringLen($V_CAM))==$V_GUI)Then
				MsgBox(16,$PROG_TITLE & "- Error","Different Versions"&@CRLF&@CRLF&$vGui&@CRLF&$vExe&@CRLF&$vCam)
				Return 0
			EndIf
		Else
			Return 0
		EndIf
	Else
		Return 0
	EndIf
	Local $ChdkScriptSupport = setCommand($SS_CAM)
	$ChdkScriptSupport = Int(StringTrimLeft($ChdkScriptSupport, StringLen($SS_CAM_RES)))
	If  @error Or(BitAND($ChdkScriptSupport,1)<>1)Then
		MsgBox(16,$PROG_TITLE & "- Error","LUA support for CHDK is required")
		Return 0
	EndIf

	$ChdkPlatform = setCommand("luar get_buildinfo().platform")
    If @error Or Not(@extended = $CMD_RESULT_STRING) Then return 0
	If iniFileReadPlatform() = 0 then
		;get cam zoom_steps for init maxZoomSteps
		Local $read_steps = setCommand("luar get_zoom_steps()")
		If Not IsInt($read_steps)Or($read_steps<1) Then Return 0
		$maxZoomStep = $read_steps-1
	Endif
	GUICtrlSetData($LZCMax, "max. Zoom: " & $maxZoomStep)
	GUICtrlSetLimit($SZC, $maxZoomStep, 0)
	iniFileRead()
	$IniState = True
	Local $ChdkVersion = setCommand("luar get_buildinfo().version")
	Local $ChdkCamLangDE = ($ChdkVersion == $CHDK_CAM_LANG_DE)
	debugWriteLine("DE="& $ChdkCamLangDE)
	_GUICtrlStatusBar_SetText($SB, StringUpper($ChdkPlatform)&" "& $ChdkVersion &" [Build: "&setCommand("luar get_buildinfo().build_number")&"]", 3)
    Return 1
EndFunc

Func iniFileRead()
	;read ini if exist
	If FileExists($IniFile) Then
		$TlTime = IniRead($IniFile, "timelapse", "time", $TlTime)
		$TlPics = IniRead($IniFile, "timelapse", "pic", $TlPics)
		GUICtrlSetData($CBSend, IniRead($IniFile, "lastCommands", "cmd_array", ""),"")
		Return 1
	Else
		Return 0
	EndIf
EndFunc

Func iniFileReadPlatform()
	;read ini if exist
	If FileExists($IniFile) Then
		IniReadSection($IniFile, $ChdkPlatform)
		If @error Then Return 0
		$MaxZoomStep = IniRead($IniFile, $ChdkPlatform, "max_zoom", $MaxZoomStep)
		Return 1
	Else
		Return 0
	EndIf
EndFunc

Func iniFileWrite()
	IniWrite($IniFile, $ChdkPlatform, "max_zoom", $MaxZoomStep)
	IniWrite($IniFile, "timelapse", "time", $TlTime)
	IniWrite($IniFile, "timelapse", "pic", $TlPics)
	IniWrite($IniFile, "lastCommands", "cmd_array", _GUICtrlComboBox_GetList($CBSend))
EndFunc

Func changeGuiLng()
	GUICtrlSetData($MFile, $LngMFile[$LngDefault])
	GUICtrlSetData($MFUploadFile, $LngMFUploadFile[$LngDefault])
	GUICtrlSetData($MFExit, $LngMFExit[$LngDefault])
	GUICtrlSetData($MLang, $LngMLang[$LngDefault])
	GUICtrlSetData($MHelp, $LngMHelp[$LngDefault])
	GUICtrlSetData($MHPrgHelp, $LngMHPrgHelp[$LngDefault])
	GUICtrlSetData($MHInfo, $LngMHInfo[$LngDefault])
EndFunc

;keyboard hook routine
Func _KeyProc($nCode, $wParam, $lParam)
    Local $tKEYHOOKS, $vkCode
    $tKEYHOOKS = DllStructCreate($tagKBDLLHOOKSTRUCT, $lParam)
    If $nCode >= 0 And $HookActive Then
		$vkCode = DllStructGetData($tKEYHOOKS, "vkCode")
		If $wParam = $WM_KEYUP And $vkCode = 13 Then ; ENTER pressed
			If ControlGetFocus($FMain) = 'Edit1' Then _GUICtrlButton_Click($BSend) ;ComboBox $CBSend = 'Edit1'
		EndIf
    EndIf
    Return _WinAPI_CallNextHookEx($HookHandle, $nCode, $wParam, $lParam)
EndFunc

; =====================================================================================
Func postGCEvent()
	GUICtrlSendToDummy($DControl)
EndFunc   ;==>DoGC
; =====================================================================================
Func emptyWorkingSet()
	; Author: ?  from AutoIt forum: http://www.autoitscript.com/forum/index.php?act=idx
	DllCall("psapi.dll", "int", "EmptyWorkingSet", "hwnd", $PtrProcess[0])
	If @error Then
		DllCall("kernel32.dll", "int", "K32EmptyWorkingSet", "hwnd", $PtrProcess[0])
	EndIf
EndFunc   ;==>_EmptyWorkingSet
; =====================================================================================

Func onAutoItExit()
;   ============================
	AdlibUnRegister("postGCEvent")
;   ============================
    _WinAPI_UnhookWindowsHookEx($HookHandle)
    DllCallbackFree($HookKeyProc)
EndFunc
